/*
 * Public Release 3
 * 
 * $Id: krt_lladdr_sioc.c,v 1.2 1997/07/17 22:43:01 chopps Exp $
 */
/*
 * ------------------------------------------------------------------------
 * 
 * Copyright (c) 1996, 1997 The Regents of the University of Michigan
 * All Rights Reserved
 *  
 * Royalty-free licenses to redistribute GateD Release
 * 3 in whole or in part may be obtained by writing to:
 * 
 * 	Merit GateDaemon Project
 * 	4251 Plymouth Road, Suite C
 * 	Ann Arbor, MI 48105
 *  
 * THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION WARRANTIES OF 
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE REGENTS OF THE
 * UNIVERSITY OF MICHIGAN AND MERIT DO NOT WARRANT THAT THE
 * FUNCTIONS CONTAINED IN THE SOFTWARE WILL MEET LICENSEE'S REQUIREMENTS OR
 * THAT OPERATION WILL BE UNINTERRUPTED OR ERROR FREE. The Regents of the
 * University of Michigan and Merit shall not be liable for
 * any special, indirect, incidental or consequential damages with respect
 * to any claim by Licensee or any third party arising from use of the
 * software. GateDaemon was originated and developed through release 3.0
 * by Cornell University and its collaborators.
 * 
 * Please forward bug fixes, enhancements and questions to the
 * gated mailing list: gated-people@gated.merit.edu.
 * 
 * ------------------------------------------------------------------------
 * 
 * Copyright (c) 1990,1991,1992,1993,1994,1995 by Cornell University.
 *     All rights reserved.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT
 * LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * GateD is based on Kirton's EGP, UC Berkeley's routing
 * daemon	 (routed), and DCN's HELLO routing Protocol.
 * Development of GateD has been supported in part by the
 * National Science Foundation.
 * 
 * ------------------------------------------------------------------------
 * 
 * Portions of this software may fall under the following
 * copyrights:
 * 
 * Copyright (c) 1988 Regents of the University of California.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms are
 * permitted provided that the above copyright notice and
 * this paragraph are duplicated in all such forms and that
 * any documentation, advertising materials, and other
 * materials related to such distribution and use
 * acknowledge that the software was developed by the
 * University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote
 * products derived from this software without specific
 * prior written permission.  THIS SOFTWARE IS PROVIDED
 * ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#define       INCLUDE_CTYPE
#define       INCLUDE_FILE
#define       INCLUDE_IOCTL
#define       INCLUDE_IF
#include "include.h"
#include "krt.h"
#include "krt_var.h"
#define PATH  "/dev/ip" 


static sockaddr_un *
krt_lladdr_get __PF2(fd, int,
                   ifr, struct ifreq *)
{
    int rc;
    struct strioctl si;
    struct ifreq ifreq_enaddr;

    si.ic_cmd = SIOCGENADDR;
    si.ic_timout = 0;
    si.ic_len = sizeof(ifreq_enaddr);
    si.ic_dp = (caddr_t) &ifreq_enaddr;
    bcopy(ifr->ifr_name, ifreq_enaddr.ifr_name, IFNAMSIZ);

    rc = ioctl(fd, I_STR, &si);

    if (rc != 0)
      return (sockaddr_un *) 0;

    return sockbuild_ll(LL_8022, (byte *) (ifreq_enaddr.ifr_enaddr), 6);
}


sockaddr_un *
krt_lladdr __PF1(ifr, struct ifreq *)
{
    int fd;
    sockaddr_un *lladdr = (sockaddr_un *) 0;

    fd = open(PATH, O_RDWR);
    if (fd < 0) {
      /* Do not report an error */
      return lladdr;
    }

    lladdr = krt_lladdr_get(fd, ifr);

    (void) close(fd);

    return lladdr;
}
